<?php

/** @var rex_addon $this */

$panel = '';

$settings = rex_post('settings', [
    ['backups', 'bool', false],
    ['api_login', 'string'],
    ['api_key', 'string'],
], null);

if (is_array($settings)) {
    foreach ($settings as $key => $value) {
        $this->setConfig($key, $value);
    }
    echo rex_view::success($this->i18n('settings_saved'));
    rex_install_webservice::deleteCache();
}

$panel .= '
            <fieldset>
                <legend>' . $this->i18n('settings_general') . '</legend>';

            $formElements = [];

                $n = [];
                $n['reverse'] = true;
                $n['label'] = '<label>' . $this->i18n('settings_backups') . '</label>';
                $n['field'] = '<input type="checkbox"  name="settings[backups]" value="1" ' . ($this->getConfig('backups') ? 'checked="checked" ' : '') . '/>';
                $formElements[] = $n;

                $fragment = new rex_fragment();
                $fragment->setVar('elements', $formElements, false);
                $panel .= $fragment->parse('core/form/checkbox.php');

$panel .= '
            </fieldset>
            <fieldset>
                <legend>' . $this->i18n('settings_myredaxo_account') . '</legend>';

            $formElements = [];

                $n = [];
                $n['label'] = '<label for="install-settings-api-login">' . $this->i18n('settings_api_login') . '</label>';
                $n['field'] = '<input class="form-control" id="install-settings-api-login" type="text" name="settings[api_login]" value="' . $this->getConfig('api_login') . '" />';
                $formElements[] = $n;

                $n = [];
                $n['label'] = '<label for="install-settings-api-key">' . $this->i18n('settings_api_key') . '</label>';
                $n['field'] = '<input class="form-control" id="install-settings-api-key" type="text" name="settings[api_key]" value="' . $this->getConfig('api_key') . '" />';
                $formElements[] = $n;

                $fragment = new rex_fragment();
                $fragment->setVar('elements', $formElements, false);
                $panel .= $fragment->parse('core/form/form.php');

$panel .= '
                </fieldset>';

            $formElements = [];

                $n = [];
                $n['field'] = '<button class="btn btn-save rex-form-aligned" type="submit" name="settings[save]" value="1">' . rex_i18n::msg('form_save') . '</button>';
                $formElements[] = $n;

                $fragment = new rex_fragment();
                $fragment->setVar('elements', $formElements, false);
                $buttons = $fragment->parse('core/form/submit.php');

$fragment = new rex_fragment();
$fragment->setVar('class', 'edit', false);
$fragment->setVar('title', $this->i18n('subpage_settings'), false);
$fragment->setVar('body', $panel, false);
$fragment->setVar('buttons', $buttons, false);
$content = $fragment->parse('core/page/section.php');

$content = '
    <form action="' . rex_url::currentBackendPage() . '" method="post">
        ' . $content . '
    </form>';

echo $content;
